/*!
 * Copyright (c) 2012 - 2022, Anaconda, Inc., and Bokeh Contributors
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * 
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 * 
 * Neither the name of Anaconda nor the names of any contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */
(function(root, factory) {
  factory(root["Bokeh"], undefined);
})(this, function(Bokeh, version) {
  let define;
  return (function(modules, entry, aliases, externals) {
    const bokeh = typeof Bokeh !== "undefined" && (version != null ? Bokeh[version] : Bokeh);
    if (bokeh != null) {
      return bokeh.register_plugin(modules, entry, aliases);
    } else {
      throw new Error("Cannot find Bokeh " + version + ". You have to load it prior to loading plugins.");
    }
  })
({
"c764d38756": function _(e,s,o,t,b){t();const i=(0,e("tslib").__importStar)(e("b4555bea44"));o.GeoViews=i;(0,e("@bokehjs/base").register_models)(i)},
"b4555bea44": function _(o,e,l,t,r){t(),r("CheckpointTool",o("fc272d6e02").CheckpointTool),r("ClearTool",o("eddee4057c").ClearTool),r("PolyVertexDrawTool",o("8288feb407").PolyVertexDrawTool),r("PolyVertexEditTool",o("5e7ea505ce").PolyVertexEditTool),r("RestoreTool",o("e81e0595cf").RestoreTool)},
"fc272d6e02": function _(o,t,e,s,i){s();const c=(0,o("tslib").__importStar)(o("@bokehjs/core/properties")),n=o("@bokehjs/core/util/array"),r=o("@bokehjs/models/tools/actions/action_tool");class l extends r.ActionToolView{doit(){const o=this.model.sources;for(const t of o){t.buffer||(t.buffer=[]);let o={};for(const e in t.data){const s=t.data[e],i=[];for(const o of s)Array.isArray(o)||ArrayBuffer.isView(o)?i.push((0,n.copy)(o)):i.push(o);o[e]=i}t.buffer.push(o)}}}e.CheckpointToolView=l,l.__name__="CheckpointToolView";class a extends r.ActionTool{constructor(o){super(o),this.tool_name="Checkpoint",this.icon="bk-tool-icon-save"}static init_CheckpointTool(){this.prototype.default_view=l,this.define({sources:[c.Array,[]]})}}e.CheckpointTool=a,a.__name__="CheckpointTool",a.__module__="geoviews.models.custom_tools",a.init_CheckpointTool()},
"eddee4057c": function _(o,e,t,s,i){s();const a=(0,o("tslib").__importStar)(o("@bokehjs/core/properties")),l=o("@bokehjs/models/tools/actions/action_tool");class r extends l.ActionToolView{doit(){for(var o of this.model.sources){for(const e in o.data)o.data[e]=[];o.change.emit(),o.properties.data.change.emit()}}}t.ClearToolView=r,r.__name__="ClearToolView";class n extends l.ActionTool{constructor(o){super(o),this.tool_name="Clear data",this.icon="bk-tool-icon-reset"}static init_ClearTool(){this.prototype.default_view=r,this.define({sources:[a.Array,[]]})}}t.ClearTool=n,n.__name__="ClearTool",n.__module__="geoviews.models.custom_tools",n.init_ClearTool()},
"8288feb407": function _(e,t,s,o,r){o();const l=(0,e("tslib").__importStar)(e("@bokehjs/core/properties")),i=e("@bokehjs/core/util/object"),a=e("@bokehjs/core/util/types"),d=e("@bokehjs/models/tools/edit/poly_draw_tool");class n extends d.PolyDrawToolView{_split_path(e,t){for(let s=0;s<this.model.renderers.length;s++){const o=this.model.renderers[s],r=o.glyph,l=o.data_source,[i,d]=[r.xs.field,r.ys.field],n=l.data[i],_=l.data[d];for(let s=0;s<n.length;s++){let o=n[s];(0,a.isArray)(o)||(o=Array.from(o),l.data[i][s]=o);let r=_[s];(0,a.isArray)(r)||(r=Array.from(r),l.data[d][s]=r);for(let a=0;a<o.length;a++)if(o[a]==e&&r[a]==t&&0!=a&&a!=o.length-1){n.splice(s+1,0,o.slice(a)),_.splice(s+1,0,r.slice(a)),o.splice(a+1),r.splice(a+1);for(const e of l.columns())e!==i&&e!=d&&l.data[e].splice(s+1,0,l.data[e][s]);return}}}}_snap_to_vertex(e,t,s){if(this.model.vertex_renderer){const o=this._select_event(e,"replace",[this.model.vertex_renderer]),r=this.model.vertex_renderer.data_source,l=this.model.vertex_renderer.glyph,[i,a]=[l.x.field,l.y.field];if(o.length){const o=r.selected.indices[0];i&&(t=r.data[i][o]),a&&(s=r.data[a][o]),"mousemove"!=e.type&&this._split_path(t,s),r.selection_manager.clear()}}return[t,s]}_set_vertices(e,t,s){const o=this.model.vertex_renderer.glyph,r=this.model.vertex_renderer.data_source,[l,d]=[o.x.field,o.y.field];if(l&&((0,a.isArray)(e)?r.data[l]=e:o.x={value:e}),d&&((0,a.isArray)(t)?r.data[d]=t:o.y={value:t}),null!=s)for(const e of(0,i.keys)(s))r.data[e]=s[e],o[e]={field:e};else for(const e of r.columns())r.data[e]=[];this._emit_cds_changes(r,!0,!0,!1)}_show_vertices(){if(!this.model.active)return;const e=[],t=[],s={};for(const e of(0,i.keys)(this.model.end_style))s[e]=[];for(let o=0;o<this.model.renderers.length;o++){const r=this.model.renderers[o],l=r.data_source,a=r.glyph,[d,n]=[a.xs.field,a.ys.field];for(const t of l.get_array(d)){Array.prototype.push.apply(e,t);for(const e of(0,i.keys)(this.model.end_style))s[e].push(this.model.end_style[e]);for(const e of(0,i.keys)(this.model.node_style))for(let o=0;o<t.length-2;o++)s[e].push(this.model.node_style[e]);for(const e of(0,i.keys)(this.model.end_style))s[e].push(this.model.end_style[e])}for(const e of l.get_array(n))Array.prototype.push.apply(t,e);if(this._drawing&&o==this.model.renderers.length-1){e.splice(e.length-1,1),t.splice(t.length-1,1);for(const e of(0,i.keys)(s))s[e].splice(s[e].length-1,1)}}this._set_vertices(e,t,s)}_remove(){const e=this.model.renderers[0],t=e.data_source,s=e.glyph,[o,r]=[s.xs.field,s.ys.field];if(o){const e=t.data[o].length-1,s=t.get_array(o)[e];s.splice(s.length-1,1),1==s.length&&t.data[o].splice(e,1)}if(r){const e=t.data[r].length-1,s=t.get_array(r)[e];s.splice(s.length-1,1),1==s.length&&t.data[r].splice(e,1)}this._emit_cds_changes(t),this._drawing=!1,this._show_vertices()}}s.PolyVertexDrawToolView=n,n.__name__="PolyVertexDrawToolView";class _ extends d.PolyDrawTool{constructor(e){super(e)}static init_PolyVertexDrawTool(){this.prototype.default_view=n,this.define({end_style:[l.Any,{}],node_style:[l.Any,{}]})}}s.PolyVertexDrawTool=_,_.__name__="PolyVertexDrawTool",_.__module__="geoviews.models.custom_tools",_.init_PolyVertexDrawTool()},
"5e7ea505ce": function _(e,t,s,i,r){i();const o=(0,e("tslib").__importStar)(e("@bokehjs/core/properties")),_=e("@bokehjs/core/util/object"),d=e("@bokehjs/core/util/types"),l=e("@bokehjs/models/tools/edit/poly_edit_tool");class n extends l.PolyEditToolView{deactivate(){this._hide_vertices(),this._selected_renderer&&(this._drawing&&(this._remove_vertex(),this._drawing=!1),this._emit_cds_changes(this._selected_renderer.data_source,!1,!0,!1))}_pan(e){if(null==this._basepoint)return;const t=this._drag_points(e,[this.model.vertex_renderer]);e.shiftKey||this._move_linked(t),this._selected_renderer&&this._selected_renderer.data_source.change.emit()}_pan_end(e){if(null==this._basepoint)return;const t=this._drag_points(e,[this.model.vertex_renderer]);e.shiftKey||this._move_linked(t),this._emit_cds_changes(this.model.vertex_renderer.data_source,!1,!0,!0),this._selected_renderer&&this._emit_cds_changes(this._selected_renderer.data_source),this._basepoint=null}_drag_points(e,t){if(null==this._basepoint)return[];const[s,i]=this._basepoint,r=[];for(const o of t){const t=this._map_drag(s,i,o),_=this._map_drag(e.sx,e.sy,o);if(null==_||null==t)continue;const[d,l]=_,[n,a]=t,[c,h]=[d-n,l-a],y=o.glyph,f=o.data_source,[u,m]=[y.x.field,y.y.field];for(const e of f.selected.indices){const t=[];u&&(t.push(f.data[u][e]),f.data[u][e]+=c),m&&(t.push(f.data[m][e]),f.data[m][e]+=h),t.push(c),t.push(h),r.push(t)}f.change.emit()}return this._basepoint=[e.sx,e.sy],r}_set_vertices(e,t,s){const i=this.model.vertex_renderer.glyph,r=this.model.vertex_renderer.data_source,[o,l]=[i.x.field,i.y.field];if(o&&((0,d.isArray)(e)?r.data[o]=e:i.x={value:e}),l&&((0,d.isArray)(t)?r.data[l]=t:i.y={value:t}),null!=s)for(const e of(0,_.keys)(s))r.data[e]=s[e],i[e]={field:e};else for(const e of r.columns())r.data[e]=[];this._emit_cds_changes(r,!0,!0,!1)}_move_linked(e){if(!this._selected_renderer)return;const t=this._selected_renderer,s=t.glyph,i=t.data_source,[r,o]=[s.xs.field,s.ys.field],_=i.data[r],d=i.data[o];for(const t of e){const[e,s,i,r]=t;for(let t=0;t<_.length;t++){const o=_[t],l=d[t];for(let t=0;t<o.length;t++)o[t]==e&&l[t]==s&&(o[t]+=i,l[t]+=r)}}}_tap(e){const t=this.model.vertex_renderer,s=this._map_drag(e.sx,e.sy,t);if(null!=s){if(this._drawing&&this._selected_renderer){let[i,r]=s;const o=t.data_source,_=t.glyph,[d,l]=[_.x.field,_.y.field],n=o.selected.indices;[i,r]=this._snap_to_vertex(e,i,r);const a=n[0];if(o.selected.indices=[a+1],d){const e=o.get_array(d),t=e[a];e[a]=i,e.splice(a+1,0,t)}if(l){const e=o.get_array(l),t=e[a];e[a]=r,e.splice(a+1,0,t)}return o.change.emit(),void this._emit_cds_changes(this._selected_renderer.data_source,!0,!1,!0)}this._select_event(e,this._select_mode(e),[t])}}_show_vertices(e){if(!this.model.active)return;const t=this._select_event(e,"replace",this.model.renderers);if(!t.length)return this._hide_vertices(),this._selected_renderer=null,void(this._drawing=!1);const s=t[0],i=s.glyph,r=s.data_source,o=r.selected.indices[0],[l,n]=[i.xs.field,i.ys.field];let a,c;l?(a=r.data[l][o],(0,d.isArray)(a)||(r.data[l][o]=a=Array.from(a))):a=i.xs.value,n?(c=r.data[n][o],(0,d.isArray)(c)||(r.data[n][o]=c=Array.from(c))):c=i.ys.value;const h={};for(const e of(0,_.keys)(this.model.end_style))h[e]=[this.model.end_style[e]];for(const e of(0,_.keys)(this.model.node_style))for(let t=0;t<a.length-2;t++)h[e].push(this.model.node_style[e]);for(const e of(0,_.keys)(this.model.end_style))h[e].push(this.model.end_style[e]);this._selected_renderer=s,this._set_vertices(a,c,h)}}s.PolyVertexEditToolView=n,n.__name__="PolyVertexEditToolView";class a extends l.PolyEditTool{constructor(e){super(e)}static init_PolyVertexEditTool(){this.prototype.default_view=n,this.define({node_style:[o.Any,{}],end_style:[o.Any,{}]})}}s.PolyVertexEditTool=a,a.__name__="PolyVertexEditTool",a.__module__="geoviews.models.custom_tools",a.init_PolyVertexEditTool()},
"e81e0595cf": function _(o,e,t,s,i){s();const r=(0,o("tslib").__importStar)(o("@bokehjs/core/properties")),n=o("@bokehjs/models/tools/actions/action_tool");class l extends n.ActionToolView{doit(){const o=this.model.sources;for(const e of o)e.buffer&&0!=e.buffer.length&&(e.data=e.buffer.pop(),e.change.emit(),e.properties.data.change.emit())}}t.RestoreToolView=l,l.__name__="RestoreToolView";class c extends n.ActionTool{constructor(o){super(o),this.tool_name="Restore",this.icon="bk-tool-icon-undo"}static init_RestoreTool(){this.prototype.default_view=l,this.define({sources:[r.Array,[]]})}}t.RestoreTool=c,c.__name__="RestoreTool",c.__module__="geoviews.models.custom_tools",c.init_RestoreTool()},
}, "c764d38756", {"index":"c764d38756","models/index":"b4555bea44","models/checkpoint_tool":"fc272d6e02","models/clear_tool":"eddee4057c","models/poly_draw":"8288feb407","models/poly_edit":"5e7ea505ce","models/restore_tool":"e81e0595cf"}, {});});
